%define expat_version           1.95.5
%define glib2_version           2.2.0
%define qt_version              3.1.0

%define lib_major 0
%define lib_api 1
%define lib_name %mklibname dbus- %{lib_api} %{lib_major}
%define lib_glib %mklibname dbus-glib- %{lib_api} %{lib_major}
%define lib_qt %mklibname dbus-qt- %{lib_api} %{lib_major}

Summary: D-BUS message bus
Name: dbus
Version: 0.22
Release: 3mdk
URL: http://www.freedesktop.org/Software/dbus/
Source0: http://freedesktop.org/Software/dbus/%{name}-%{version}.tar.bz2
Source1: http://freedesktop.org/Software/dbus/%{name}-docs.tar.bz2 
# (fc) 0.20-1mdk fix lock directory location and start/stop order
Patch0: dbus-0.20-lockdir.patch.bz2
# (fc) 0.22-1mdk add console policy
Patch1: dbus-0.22-console-auth.patch.bz2
# (gb) 0.22-2mdk fix detection of moc path
Patch2: dbus-0.22-qt-moc.patch.bz2
# (gb) 0.22-2mdk merge in RH in64 fix for python bindings
Patch3: dbus-0.22-python-int64.patch.bz2
License: AFL/GPL
Group: System/Servers
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: expat-devel >= %{expat_version}
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: qt3-devel    >= %{qt_version}
BuildRequires: gtk+2-devel
BuildRequires: python-devel
BuildRequires: pyrex >= 0.9
BuildRequires: automake1.7
BuildRequires: autoconf2.5 >= 2.54
PreReq: rpm-helper

%description
D-BUS is a system for sending messages between applications. It is
used both for the systemwide message bus service, and as a
per-user-login-session messaging facility.

%package -n %{lib_name}
Summary: Shared library for using D-BUS
Group: System/Libraries

%description -n %{lib_name}
D-BUS shared library.

%package -n %{lib_name}-devel
Summary: Libraries and headers for D-BUS
Group: Development/C
Requires: %{name} = %{version}-%{release}
Requires: %{lib_name} = %{version}-%{release}
Requires: %{lib_glib} = %{version}-%{release}
Requires: %{lib_qt} = %{version}-%{release}
Provides: lib%{name}-1-devel = %{version}-%{release}
Provides: lib%{name}-devel = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}

%description -n %{lib_name}-devel

Headers and static libraries for D-BUS.

%package -n %{lib_glib}
Summary: GLib-based library for using D-BUS
Group: System/Libraries

%description -n %{lib_glib}
D-BUS add-on library to integrate the standard D-BUS library with
the GLib thread abstraction and main loop.

%package -n %{lib_qt}
Summary: Qt-based library for using D-BUS
Group: Development/C++

%description -n %{lib_qt}
D-BUS add-on library to integrate the standard D-BUS library with
the Qt thread abstraction and main loop.

%package x11
Summary: X11-requiring add-ons for D-BUS
Group: System/Servers

%description x11
D-BUS contains some tools that require Xlib to be installed, those are
in this separate package so server systems need not install X.

%package python
Summary: Python bindings for D-BUS
Group: Development/Python
Requires: dbus = %{version}-%{release}
 
%description python
The dbus-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by the D-BUS library.

%prep
%setup -q -a1
%patch0 -p1 -b .lockdir
%patch1 -p1 -b .console
%patch2 -p1 -b .qt-moc
%patch3 -p1 -b .python-int64

#needed by patch0
aclocal-1.7
automake-1.7

#needed by patch2
autoconf

%build

#gw so we can find moc
export PATH=%_libdir/qt3/bin:$PATH
%configure2_5x --enable-python --disable-tests --disable-verbose-mode --disable-asserts --disable-mono --disable-mono-docs --with-system-pid-file=%{_var}/run/messagebus.pid --with-system-socket=%{_var}/run/dbus/system_dbus_socket --with-session-socket-dir=/tmp
make

make check

%install
rm -rf %{buildroot}

%makeinstall_std

# move lib to /, because it might be needed by hotplug script, before
# /usr is mounted
mkdir -p $RPM_BUILD_ROOT/%{_lib} 
mv $RPM_BUILD_ROOT%{_libdir}/*dbus-1*.so* $RPM_BUILD_ROOT/%{_lib} 

#remove unpackaged file
rm -f $RPM_BUILD_ROOT%{_bindir}/dbus-glib-tool $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.a $RPM_BUILD_ROOT%{_libdir}/*.la

%clean
rm -rf %{buildroot}

%pre
%_pre_useradd messagebus / /sbin/nologin
%_pre_groupadd daemon messagebus

%post -n %{lib_name} -p /sbin/ldconfig
%postun -n %{lib_name} -p /sbin/ldconfig

%post
%_post_service messagebus

%postun
%_postun_userdel messagebus
%_postun_groupdel daemon messagebus

%preun
%_preun_service messagebus

%post -n %{lib_qt} -p /sbin/ldconfig
%postun -n %{lib_qt} -p /sbin/ldconfig

%post -n %{lib_glib} -p /sbin/ldconfig
%postun -n %{lib_glib} -p /sbin/ldconfig

%triggerpostun -- dbus < 0.21-4mdk
/sbin/chkconfig --del messagebus
/sbin/chkconfig --add messagebus

%files
%defattr(-,root,root)

%doc COPYING ChangeLog NEWS

%dir %{_sysconfdir}/dbus-1
%config(noreplace) %{_sysconfdir}/dbus-1/*.conf
%config(noreplace) %{_sysconfdir}/rc.d/init.d/*
%dir %{_sysconfdir}/dbus-1/system.d
%dir %{_var}/run/dbus
%dir %{_libdir}/dbus-1.0
%{_bindir}/dbus-daemon-1
%{_bindir}/dbus-send
%{_bindir}/dbus-cleanup-sockets
%{_datadir}/man/man*/*
%{_libdir}/dbus-1.0/services

%files -n %{lib_name}
%defattr(-,root,root)
/%{_lib}/*dbus-1*.so.*

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc doc/*
%{_libdir}/lib*.a
%{_libdir}/lib*.so
/%{_lib}/lib*.so
%{_libdir}/dbus-1.0/include
%{_libdir}/pkgconfig/*
%{_includedir}/*

%files -n %{lib_glib}
%defattr(-,root,root)
%{_libdir}/*glib*.so.*

%files -n %{lib_qt}
%defattr(-,root,root)
%{_libdir}/*qt*.so.*

%files x11
%defattr(-,root,root)
%{_bindir}/dbus-launch
%{_bindir}/dbus-monitor
%{_bindir}/dbus-viewer

%files python
%defattr(-,root,root)
%{_libdir}/python*/site-packages/dbus*

%changelog
* Thu Sep 30 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.22-3mdk
- explicitly disable Mono bindings

* Thu Sep 30 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.22-2mdk
- fix detection of moc path
- merge in RH in64 fix for python bindings

* Fri Aug 13 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.22-1mdk
- Release 0.22
- Remove patch1 (merged upstream)
- enable libtoolize 
- Patch1 (Fedora): add console policy

* Mon Aug 09 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.21-4mdk
- Update patch 20 to change start order (should fix bluetooth daemon start)

* Wed Jun 16 2004 Stew Benedict <sbenedict@mandrakesoft.com> 0.21-3mdk
- add docs to -devel, dbus-monitor fixes from cvs (patch1)

* Fri Jun  4 2004 Laurent Montel <lmontel@mandrakesoft.com> 0.21-2mdk
- Rebuild

* Mon Apr 19 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.21-1mdk
- fix qt build
- drop merged patch 1
- fix URL
- new version

* Sat Jan 31 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.20-7mdk
- fix buildrequires

* Thu Jan 29 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-6mdk
- Don't package .la, since we are moving some lib to %{_lib}

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-5mdk
- Enable python bindings
- Patch1 (CVS): fix python signals

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-4mdk
- Add missing deps in devel package

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-3mdk
- Move dbus shared library to %{_lib}, needed for hotplug script (Mdk bug 7053)

* Wed Jan 14 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-2mdk
- Fix session socket directory location

* Mon Jan 12 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-1mdk
- Initial Mdk package
- Patch0: fix lock directory location

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-6
- hmm, dbus doesn't support uids in the config file. fix.

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-5
- put uid instead of username in the config file, to keep things working with name change

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-4
- make subpackages require the specific release, not just version, of base package

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-3
- change system user "messagebus" -> "dbus" to be under 8 chars

* Mon Sep 29 2003 Havoc Pennington <hp@redhat.com> 0.13-2
- see if removing qt subpackage for now will get us through the build system,
  qt bindings not useful yet anyway

* Sun Sep 28 2003 Havoc Pennington <hp@redhat.com> 0.13-1
- 0.13 fixes a little security oops

* Mon Aug  4 2003 Havoc Pennington <hp@redhat.com> 0.11.91-3
- break the tiny dbus-launch that depends on X into separate package
  so a CUPS server doesn't need X installed

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Sat May 17 2003 Havoc Pennington <hp@redhat.com> 0.11.91-1
- 0.11.91 cvs snap properly merges system.d

* Fri May 16 2003 Havoc Pennington <hp@redhat.com> 0.11.90-1
- build a cvs snap with a few more fixes

* Fri May 16 2003 Havoc Pennington <hp@redhat.com> 0.11-2
- fix a crash that was breaking cups

* Thu May 15 2003 Havoc Pennington <hp@redhat.com> 0.11-1
- 0.11

* Thu May 15 2003 Havoc Pennington <hp@redhat.com> 0.10.90-1
- use rc.d/init.d not init.d, bug #90192
- include the new man pages

* Fri Apr 11 2003 Havoc Pennington <hp@redhat.com> 0.9-1
- 0.9
- export QTDIR explicitly
- re-enable qt, the problem was most likely D-BUS configure

* Tue Apr  1 2003 Havoc Pennington <hp@redhat.com> 0.6.94-1
- update from CVS with a fix to set uid after gid

* Tue Apr  1 2003 Havoc Pennington <hp@redhat.com> 0.6.93-1
- new cvs snap that actually forks to background and changes 
  user it's running as and so forth
- create our system user in pre

* Mon Mar 31 2003 Havoc Pennington <hp@redhat.com> 0.6.92-1
- fix for "make check" test that required a home directory

* Mon Mar 31 2003 Havoc Pennington <hp@redhat.com> 0.6.91-1
- disable qt for now because beehive hates me
- pull a slightly newer cvs snap that creates socket directory
- cat the make check log after make check fails

* Mon Mar 31 2003 Havoc Pennington <hp@redhat.com> 0.6.90-1
- initial build

